<?php

class subversion_log_parser
{
   /**
   var $current_item;
   var $commits; // Listing data
   */
   function parse ($XMLData)
   {
      $parser = xml_parser_create();
      $this->commits = array();
      $this->current_item = null;

      //This is the RIGHT WAY to set everything inside the object.
      xml_set_object ( $parser, $this );
      xml_parser_set_option ( $parser, XML_OPTION_CASE_FOLDING, 0 );

      xml_set_element_handler ( $parser, 'tag_start', 'tag_end' );
      xml_set_character_data_handler ( $parser, 'tag_content' );

      return xml_parse ( $parser, $XMLData );
   }

/*
<logentry revision="101">
   <author>halkeye</author>
   <date>2006-08-28T04:50:54.017629Z</date>
   <paths>
      <path action="A">/trunk/drupal_weeklies/semester.css</path>
      <path action="D">/trunk/drupal_weeklies/TODO</path>
      <path action="M">/trunk/drupal_weeklies/semester.module</path>
      <path action="M">/trunk/drupal_weeklies/weeklies.module</path>
   </paths>
   <msg>Attempting to implement weeklies module properly</msg>
</logentry>
*/
   function tag_start($parser,$tag, $attr) {
      switch ($tag) {
         case 'logentry':
            $this->current_item = new StdClass;
            $this->current_item->revision = intval($attr['revision']);
            break;
         case 'path':
            $this->current_path->action = $attr['action'];
            break;
      }
   }

   function tag_end($parser,$tag) {
      if (!$this->current_item) {
         return;
      }

      switch ($tag) {
         case 'paths':
            /* Ignore me */
            break;
         case 'path':
           /** FIXME: only do by rid */
            $this->current_path->file = trim($this->data); 
            $pid = null;
            foreach (array('trunk_path','branch_path','tag_path') as $field) {
              $pid = db_result(db_query("SELECT nid FROM {subversion_projects} WHERE rid=%d AND '%s' LIKE CONCAT($field, '%%') ORDER BY LENGTH('%s')-LENGTH($field) LIMIT 1",
                $this->rid,
                $this->current_path->file,
                $this->current_path->file
              ));
              $this->current_path->branch = NULL; 
              if ($pid) {
                if ($field != 'trunk_path') {
                  $filename = substr($this->current_path->file, strlen($ret['branch_path']));;
                  $parts = explode('/', $filename);
                  if (!$parts[0]) { array_shift($parts); }
                  $this->current_path->branch = $parts[0]; 
                }
                break;
              }
            }
            $this->current_path->pid = $pid; 
            $this->current_item->files[] = $this->current_path;
            unset($this->current_path);
            break;
         case 'date':
            $time = $this->data;
            list($time) = explode('.', $time);
            $t = strtotime($time);
            $zone = intval(date("O"))/100;
            $t += $zone*60*60;
            $this->current_item->date = $t;
            break;
         case 'logentry':
            $uid = db_result(db_query("SELECT uid FROM {subversion_accounts} WHERE name='%s'", $this->current_item->author));
            $this->current_item->uid = $uid; 
            $this->current_item->message = $this->current_item->msg; 

            $this->commits[] = $this->current_item;
            $this->last_revision = max($this->current_item->revision, $this->last_revision);
            $this->current_item = null;
            break;
         default:
            $this->current_item->$tag = $this->data;
            break;
      }
      $this->data = '';
   }

   function tag_content($parser,$data) {
      if (!$this->current_item) {
         return;
      }
      $this->data .= trim($data);
   }

   /* ... */

}
